---
Name: "validation-stop"
Description: "Stop a validation run and report the results"
Documentation: |
  This task ends a given Validtion stage.  No other tasks should follow it on
  the stage, and the only other task that should preceed is the `validation-start`
  task.

  Tasks will be dynamically injected in to the workflow if they have been specified
  by the appropriate control Params prior to this task.

Meta:
  color: "blue"
  icon: "bug"
  title: "RackN Content"
  feature-flags: "sane-exit-codes"
Templates:
  - Name: "validation_stop.sh"
    Meta:
      OS: "linux,darwin"
    Contents: |
      #!/usr/bin/env bash
      # Copyright RackN, 2019

      {{ template "prelude.tmpl" . }}
      {{ template "validation-lib.tmpl" . }}

      # default return code of 0 (success)
      RC=0

      # Print Errors
      {{ if ( .Param "validation/errors-ignore" ) -}}
      echo ">>> Validation errors found - these errors have been marked IGNORE:"
      {{ range $index, $ignore := .Param "validation/errors-ignore" -}}
      cat <<EOF{{$index}}
      {{$ignore}}
      EOF{{$index}}
      {{ end -}}
      echo ""
      {{ end -}}

      # Print Errors
      {{ if ( .Param "validation/errors" ) -}}
      echo ">>> Validation errors found - these errors are FATAL:"
      {{ range $index, $error := .Param "validation/errors" -}}
      cat >j.data <<EOF{{$index}}
      {{$error}}
      EOF{{$index}}
      job_error "$(cat j.data)"
      rm -f j.data
      {{ end -}}
      echo ""
      {{ end -}}

      {{ if and ( eq (len (.Param "validation/errors-ignore")) 0 ) ( eq (len (.Param "validation/errors")) 0 ) -}}
      echo ">>> No errors found (ignored or fatal)"
      {{ else }}

      {{ if eq (len (.Param "validation/errors-ignore")) 0 -}}
      echo ""
      echo ">>> No IGNORE validation errors found"
      {{ else -}}
      echo ""
      echo "{{len (.Param "validation/errors-ignore")}} errors found marked IGNORE."
      {{ end -}}

      {{ if eq (len (.Param "validation/errors")) 0 -}}
      echo ""
      echo ">>> No fatal validation errors found"
      {{ else -}}
      RC=1
      echo ""
      echo "{{len (.Param "validation/errors")}} fatal errors found"
      {{ end -}}

      {{ end -}}

      exit $RC

  - Name: "validation_stop.ps1"
    Meta:
      OS: "windows"
    Contents: |
      Write-Host "Validation stop not implemented for windows"
      exit 0
  - Name: "validation_stop-esxi.sh"
    Meta:
      OS: "esxi"
    Contents: |
      #!/bin/sh
      echo "Validation stop not implemented for esxi"
      exit 0
